"use strict";

exports.__esModule = true;
exports.anyToDate = anyToDate;

var _dateFns = require("date-fns");

var _utils = require("../utils");

/**
 * 增强版的 toDate，支持：
 * - 秒时间戳、毫秒时间戳；
 * - Date 实例；
 * - 符合 ISO 标准的时间字符串。
 *
 * @param value 要转换的值
 * @returns 返回转换后的 Date 实例
 */
function anyToDate(value) {
  if (typeof value === 'string') {
    if ((0, _utils.isNumeric)(value)) {
      value = Number(value);
    } else {
      value = (0, _dateFns.parseISO)(value);
    }
  }

  if (typeof value === 'number' && String(value).length === 10) {
    value *= 1000;
  }

  return (0, _dateFns.toDate)(value);
}