"use strict";

exports.__esModule = true;
exports.numeralDayToChineseDay = numeralDayToChineseDay;

/**
 * 数字星期。
 *
 * @public
 */
var dayMap = {
  0: '日',
  1: '一',
  2: '二',
  3: '三',
  4: '四',
  5: '五',
  6: '六',
  7: '日'
};
/**
 * 数字星期转中文星期。`0` 和 `7` 都视为星期日。
 *
 * @public
 * @param day 数字的星期几
 * @returns 返回中文的星期几
 * @example
 * ```typescript
 * numeralDayToChineseDay(0) // => 日
 * numeralDayToChineseDay(1) // => 一
 * numeralDayToChineseDay(5) // => 五
 * numeralDayToChineseDay(7) // => 日
 * ```
 */

function numeralDayToChineseDay(day) {
  return dayMap[day];
}