"use strict";

exports.__esModule = true;
exports.ensureInMiniProgram = ensureInMiniProgram;

var _utils = require("../utils");

var $mp;
/**
 * 确保当前在小程序环境并执行回调。
 *
 * @param cb 要执行的回调，第一个参数为小程序 API 挂载的全局变量
 * @returns 返回回调的执行结果
 */

function ensureInMiniProgram(cb) {
  if ($mp === undefined) {
    $mp = (0, _utils.inMiniProgram)();
  }

  if ($mp) {
    return cb($mp);
  }

  throw new Error('不在小程序环境中');
}