"use strict";

exports.__esModule = true;
exports.getCurrentPageQuery = getCurrentPageQuery;

var _ensureInMiniProgram = require("./ensureInMiniProgram");

var _utils = require("../utils");

/**
 * 获取当前页面的查询参数，已经对每个值执行了 decodeURIComponent。
 *
 * @param pageInstance 页面实例，默认当前页面
 * @returns 返回当前页面的查询参数
 */
function getCurrentPageQuery(pageInstance) {
  return (0, _ensureInMiniProgram.ensureInMiniProgram)(function () {
    pageInstance = pageInstance || (0, _utils.last)(getCurrentPages());
    var query = (0, _utils.mapValues)(pageInstance.options || {}, function (value) {
      return value && decodeURIComponent(value);
    });
    return query;
  });
}