"use strict";

exports.__esModule = true;
exports.getCurrentPageUrl = getCurrentPageUrl;

var _utils = require("../utils");

var _ensureInMiniProgram = require("./ensureInMiniProgram");

var _getCurrentPagePath = require("./getCurrentPagePath");

var _getCurrentPageQuery = require("./getCurrentPageQuery");

/**
 * 获取当前页面的地址（包含查询参数）。
 *
 * @param pageInstance 页面实例，默认当前页面
 * @returns 返回当前页面的地址
 */
function getCurrentPageUrl(pageInstance) {
  return (0, _ensureInMiniProgram.ensureInMiniProgram)(function () {
    var path = (0, _getCurrentPagePath.getCurrentPagePath)(pageInstance);
    var query = (0, _getCurrentPageQuery.getCurrentPageQuery)(pageInstance);
    var queryString = (0, _utils.createUrlQueryString)(query);
    var url = "" + path + (queryString ? "?" + queryString : '');
    return url;
  });
}