"use strict";

exports.__esModule = true;
exports.getEmailUrl = getEmailUrl;

var _createUrlQueryString = require("./createUrlQueryString");

/**
 * 获取邮件链接。
 *
 * @param options 选项
 */
function getEmailUrl(options) {
  var to = options.to,
      cc = options.cc,
      bcc = options.bcc,
      subject = options.subject,
      body = options.body;
  var url = "mailto:" + (Array.isArray(to) ? to.join(',') : to);

  if (cc || bcc || subject || body) {
    url += "?" + (0, _createUrlQueryString.createUrlQueryString)({
      cc: cc && (Array.isArray(cc) ? cc.join(',') : cc),
      bcc: bcc && (Array.isArray(bcc) ? bcc.join(',') : bcc),
      subject: subject,
      body: body
    });
  }

  return url;
}