"use strict";

exports.__esModule = true;
exports.inAndroid = inAndroid;

var _inBrowser = require("./inBrowser");

var _inMiniProgram = require("./inMiniProgram");

var yes;
/**
 * 检查是否在 Android 设备中。
 *
 * @returns 返回检查结果
 * @example
 * ```typescript
 * if (inAndroid()) {
 *   console.log('你在 Android 设备中')
 * }
 * ```
 */

function inAndroid() {
  if (yes == null) {
    var mp = (0, _inMiniProgram.inMiniProgram)();

    if (mp) {
      var sysInfo = mp.getSystemInfoSync();
      yes = sysInfo.platform === 'android' || /Android/i.test(sysInfo.system);
    } else {
      yes = (0, _inBrowser.inBrowser)() && typeof window.navigator === 'object' && /Android/i.test(window.navigator.userAgent || '');
    }
  }

  return yes;
}