"use strict";

exports.__esModule = true;
exports.isPossibleChineseMobilePhoneNumber = isPossibleChineseMobilePhoneNumber;

var _regexp = require("../regexp");

var regExp = _regexp.phoneNumberRegExpBuilder.build({
  exact: true
});
/**
 * 检测传入的值是否可能是中国的手机号码。
 *
 * @public
 * @param value 要检测的值
 * @returns 返回检测结果
 * @example
 * ```typescript
 * isPossibleChineseMobilePhoneNumber('10086') // => false
 * isPossibleChineseMobilePhoneNumber('18087030088') // => true
 * ```
 */


function isPossibleChineseMobilePhoneNumber(value) {
  return regExp.test(String(value));
}