"use strict";

exports.__esModule = true;
exports.sampleBy = sampleBy;

var _lodashUni = require("lodash-uni");

function sampleBy(collection, iteratee) {
  if ((0, _lodashUni.isArray)(collection)) {
    return (0, _lodashUni.sample)(collection.map(iteratee));
  } else if ((0, _lodashUni.isObject)(collection)) {
    var values = [];
    (0, _lodashUni.forOwn)(collection, function (v, k) {
      return values.push(iteratee(v, k));
    });
    return (0, _lodashUni.sample)(values);
  }

  return undefined;
}