import { ensureInMiniProgram } from "./ensureInMiniProgram.js";
import { last, mapValues } from "../utils/index.js";
/**
 * 获取当前页面的查询参数，已经对每个值执行了 decodeURIComponent。
 *
 * @param pageInstance 页面实例，默认当前页面
 * @returns 返回当前页面的查询参数
 */

export function getCurrentPageQuery(pageInstance) {
  return ensureInMiniProgram(function () {
    pageInstance = pageInstance || last(getCurrentPages());
    var query = mapValues(pageInstance.options || {}, function (value) {
      return value && decodeURIComponent(value);
    });
    return query;
  });
}