import { useState } from 'react';
import { useUpdateEffect } from 'react-use';
/**
 * 给 useState 插上依赖的翅膀。依赖变化时会更新状态。
 *
 * @param state 状态
 * @param deps 依赖
 * @returns 返回结果同 useState
 */

export function useStateWithDeps(state, deps) {
  var _useState = useState(state),
      value = _useState[0],
      setValue = _useState[1];

  useUpdateEffect(function () {
    setValue(state);
  }, deps);
  return [value, setValue];
}