/**
 * 正则表达式收集。
 *
 * @packageDocumentation
 */

export declare const blankCharsRegExpBuilder: RegExpBuilder;

export declare const blobUrlRegExpBuilder: RegExpBuilder;

export declare const dataUrlRegExpBuilder: RegExpBuilder;

export declare const emailRegExpBuilder: RegExpBuilder;

export declare const emojiRegExpBuilder: RegExpBuilder;

export declare const phoneNumberRegExpBuilder: RegExpBuilder;

export declare class RegExpBuilder {
    private options;
    constructor(options: RegExpBuilderOptions);
    getBaseRegExp(): RegExp;
    build(options?: RegExpBuilderBuildOptions): RegExp;
}

export declare interface RegExpBuilderBuildOptions {
    /** `g` */
    global?: boolean;
    /** `^...$` */
    exact?: boolean;
    /** `...+` */
    repeat?: boolean;
}

export declare interface RegExpBuilderOptions {
    /** 基础正则表达式 */
    baseRegExp: RegExp;
}

export { }
