import { inAndroid } from "./inAndroid.js";
import { inBrowser } from "./inBrowser.js";
import { inDeno } from "./inDeno.js";
import { inIOS } from "./inIOS.js";
import { inMiniProgram } from "./inMiniProgram.js";
import { inNodeJS } from "./inNodeJS.js";
import { inTaro } from "./inTaro.js";
import { inWechatWebView } from "./inWechatWebView.js";
var env;
/**
 * 获取运行环境信息。
 *
 * @returns 返回运行环境信息
 */

export function getEnvironment() {
  if (env == null) {
    env = {
      browser: inBrowser(),
      wechatWebView: inWechatWebView(),
      miniProgram: !!inMiniProgram(),
      wechatMiniProgram: !!inMiniProgram('微信'),
      ios: inIOS(),
      android: inAndroid(),
      nodejs: inNodeJS(),
      deno: inDeno(),
      taro: inTaro()
    };
  }

  return env;
}