import { inBrowser } from "./inBrowser.js";
import { inMiniProgram } from "./inMiniProgram.js";
var yes;
/**
 * 检查是否在 iOS 设备中。
 *
 * @returns 返回检查结果
 * @example
 * ```typescript
 * if (inIOS()) {
 *   console.log('你在 iOS 设备中')
 * }
 * ```
 */

export function inIOS() {
  if (yes == null) {
    var mp = inMiniProgram();

    if (mp) {
      var sysInfo = mp.getSystemInfoSync();
      yes = sysInfo.platform === 'ios' || /iOS/i.test(sysInfo.system);
    } else {
      yes = inBrowser() && typeof window.navigator === 'object' && /iPad|iPhone|iPod/i.test(window.navigator.platform || '');
    }
  }

  return yes;
}