import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { isBoolean } from "../utils/index.js";
import { VaeLocale } from "./VaeLocale.js";
import { VaeSchema } from "./VaeSchema.js";
export var VaeBooleanSchema = /*#__PURE__*/function (_VaeSchema) {
  _inheritsLoose(VaeBooleanSchema, _VaeSchema);

  function VaeBooleanSchema(message) {
    var _this;

    if (message === void 0) {
      message = VaeLocale.boolean.type;
    }

    _this = _VaeSchema.call(this, {
      type: 'boolean'
    }) || this;

    _this.transform(Boolean).check({
      fn: isBoolean,
      message: message
    });

    return _this;
  }

  var _proto = VaeBooleanSchema.prototype;

  _proto.true = function _true(message) {
    if (message === void 0) {
      message = VaeLocale.boolean.true;
    }

    return this.check({
      fn: function fn(v) {
        return v === true;
      },
      message: message,
      tag: 'true'
    });
  };

  _proto.false = function _false(message) {
    if (message === void 0) {
      message = VaeLocale.boolean.false;
    }

    return this.check({
      fn: function fn(v) {
        return v === false;
      },
      message: message,
      tag: 'false'
    });
  };

  return VaeBooleanSchema;
}(VaeSchema);