import Redis from 'ioredis';
import { CookieJar } from 'tough-cookie';
import { isPlainObject } from "../utils/index.js"; // @ts-ignore

import _RedisCookieStore from 'tough-cookie-redisstore';
const RedisCookieStore = _RedisCookieStore;

/**
 * 使用 Redis 作为 Cookie Jar。
 */
export class RedisCookieJar extends CookieJar {
  constructor(options) {
    const redis = isPlainObject(options.redis) ? new Redis(options.redis) : options.redis;
    super(new RedisCookieStore(`${RedisCookieJar.prefix}${options.key}`, {
      redis
    }), options);
  }

}
RedisCookieJar.prefix = '@@@@COOKIE@@@@';