import { j2xParser as J2XParser } from 'fast-xml-parser';
const arrayTagName = 'item';
const attrTagName = '@__attr__@';
const textTagName = '@__text__@';
const cdataTagName = '@__cdata__@';
/**
 * 创建 XML 文本。
 *
 * @param data 数据
 * @param options 选项
 */

export function createXml(data, options) {
  return new J2XParser({ ...options,
    attrNodeName: attrTagName,
    textNodeName: textTagName,
    cdataTagName: cdataTagName
  }).parse(data);
}

createXml.array = function (value) {
  return {
    [arrayTagName]: value
  };
};

createXml.attr = function (value) {
  return {
    [attrTagName]: value
  };
};

createXml.text = function (value) {
  return {
    [textTagName]: value
  };
};

createXml.cdata = function (value) {
  return {
    [cdataTagName]: value
  };
};